## mingw-w64-blender-4.0.2-12.src.tar.zst

=== intern/openvdb/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2015 Blender Authors
#
# SPDX-License-Identifier: GPL-2.0-or-later

set(INC
  .
)

set(INC_SYS
)

set(SRC
  openvdb_capi.h
)

set(LIB
  PRIVATE bf::intern::guardedalloc
)

if(WITH_OPENVDB)
  add_definitions(-DWITH_OPENVDB ${OPENVDB_DEFINITIONS})

  list(APPEND INC_SYS
    ${OPENVDB_INCLUDE_DIRS}
  )

  list(APPEND SRC
    openvdb_capi.cc
  )

  list(APPEND LIB
    ${OPENVDB_LIBRARIES}
  )
endif()

blender_add_lib(bf_intern_openvdb "${SRC}" "${INC}" "${INC_SYS}" "${LIB}")

=== intern/cycles/scene/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2011-2021 Blender Foundation
#
# SPDX-License-Identifier: Apache-2.0

set(INC
  ..
  ../../sky/include
)

set(SRC
  alembic.cpp
  alembic_read.cpp
  attribute.cpp
  background.cpp
  bake.cpp
  camera.cpp
  colorspace.cpp
  constant_fold.cpp
  devicescene.cpp
  film.cpp
  geometry.cpp
  geometry_attributes.cpp
  geometry_bvh.cpp
  geometry_mesh.cpp
  hair.cpp
  image.cpp
  image_oiio.cpp
  image_sky.cpp
  image_vdb.cpp
  integrator.cpp
  light.cpp
  light_tree.cpp
  mesh.cpp
  mesh_displace.cpp
  mesh_subdivision.cpp
  procedural.cpp
  pointcloud.cpp
  object.cpp
  osl.cpp
  particles.cpp
  pass.cpp
  curves.cpp
  scene.cpp
  shader.cpp
  shader_graph.cpp
  shader_nodes.cpp
  stats.cpp
  svm.cpp
  tables.cpp
  tabulated_sobol.cpp
  volume.cpp
)

set(SRC_HEADERS
  alembic.h
  alembic_read.h
  attribute.h
  bake.h
  background.h
  camera.h
  colorspace.h
  constant_fold.h
  devicescene.h
  film.h
  geometry.h
  hair.h
  image.h
  image_oiio.h
  image_sky.h
  image_vdb.h
  integrator.h
  light.h
  light_tree.h
  mesh.h
  object.h
  osl.h
  particles.h
  pass.h
  procedural.h
  pointcloud.h
  curves.h
  scene.h
  shader.h
  shader_graph.h
  shader_nodes.h
  stats.h
  svm.h
  tables.h
  tabulated_sobol.h
  volume.h
)

set(LIB
  cycles_bvh
  cycles_device
  cycles_integrator
  cycles_subd
  cycles_util
)

if(CYCLES_STANDALONE_REPOSITORY)
  list(APPEND LIB extern_sky)
else()
  list(APPEND LIB bf_intern_sky)
endif()

if(WITH_CYCLES_OSL)
  list(APPEND LIB
    cycles_kernel_osl
  )

  set_property(SOURCE osl.cpp PROPERTY COMPILE_FLAGS ${RTTI_DISABLE_FLAGS})
endif()

if(WITH_OPENCOLORIO)
  add_definitions(-DWITH_OCIO)
  list(APPEND INC_SYS
    ${OPENCOLORIO_INCLUDE_DIRS}
  )
  list(APPEND LIB
    ${OPENCOLORIO_LIBRARIES}
  )
  if(WIN32 AND NOT USD_OVERRIDE_OPENCOLORIO)
    add_definitions(-DOpenColorIO_SKIP_IMPORTS)
  endif()
endif()

if(WITH_OPENVDB)
  add_definitions(-DWITH_OPENVDB ${OPENVDB_DEFINITIONS})
  list(APPEND INC_SYS
    ${OPENVDB_INCLUDE_DIRS}
  )
  list(APPEND LIB
    ${OPENVDB_LIBRARIES}
  )
endif()

if(WITH_ALEMBIC)
  add_definitions(-DWITH_ALEMBIC)
  list(APPEND INC_SYS
    ${ALEMBIC_INCLUDE_DIRS}
  )
  list(APPEND LIB
    ${ALEMBIC_LIBRARIES}
  )
endif()

if(WITH_NANOVDB)
  list(APPEND INC_SYS
    ${NANOVDB_INCLUDE_DIRS}
  )
endif()

include_directories(${INC})
include_directories(SYSTEM ${INC_SYS})

cycles_add_library(cycles_scene "${LIB}" ${SRC} ${SRC_HEADERS})

=== source/blender/compositor/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2011 Blender Authors
#
# SPDX-License-Identifier: GPL-2.0-or-later

add_subdirectory(realtime_compositor)

if(WITH_COMPOSITOR_CPU)
  set(INC
    .
    intern
    nodes
    operations
    ../blenkernel
    ../blentranslation
    ../depsgraph
    ../imbuf
    ../makesrna
    ../nodes
    ../windowmanager
    ../nodes/composite
    ../nodes/intern
    ../render
    ../render/intern
    ../../../extern/clew/include
    ../../../intern/clog

    # RNA_prototypes.h
    ${CMAKE_BINARY_DIR}/source/blender/makesrna
  )

  set(INC_SYS

  )

  set(SRC
    COM_compositor.h
    COM_defines.h

    intern/COM_BufferArea.h
    intern/COM_BufferOperation.cc
    intern/COM_BufferOperation.h
    intern/COM_BufferRange.h
    intern/COM_BuffersIterator.h
    intern/COM_CPUDevice.cc
    intern/COM_CPUDevice.h
    intern/COM_ChunkOrder.cc
    intern/COM_ChunkOrder.h
    intern/COM_ChunkOrderHotspot.cc
    intern/COM_ChunkOrderHotspot.h
    intern/COM_CompositorContext.cc
    intern/COM_CompositorContext.h
    intern/COM_ConstantFolder.cc
    intern/COM_ConstantFolder.h
    intern/COM_Converter.cc
    intern/COM_Converter.h
    intern/COM_Debug.cc
    intern/COM_Debug.h
    intern/COM_Device.cc
    intern/COM_Device.h
    intern/COM_Enums.cc
    intern/COM_Enums.h
    intern/COM_ExecutionGroup.cc
    intern/COM_ExecutionGroup.h
    intern/COM_ExecutionModel.cc
    intern/COM_ExecutionModel.h
    intern/COM_ExecutionSystem.cc
    intern/COM_ExecutionSystem.h
    intern/COM_FullFrameExecutionModel.cc
    intern/COM_FullFrameExecutionModel.h
    intern/COM_MemoryBuffer.cc
    intern/COM_MemoryBuffer.h
    intern/COM_MemoryProxy.cc
    intern/COM_MemoryProxy.h
    intern/COM_MetaData.cc
    intern/COM_MetaData.h
    intern/COM_MultiThreadedOperation.cc
    intern/COM_MultiThreadedOperation.h
    intern/COM_MultiThreadedRowOperation.cc
    intern/COM_MultiThreadedRowOperation.h
    intern/COM_Node.cc
    intern/COM_Node.h
    intern/COM_NodeConverter.cc
    intern/COM_NodeConverter.h
    intern/COM_NodeGraph.cc
    intern/COM_NodeGraph.h
    intern/COM_NodeOperation.cc
    intern/COM_NodeOperation.h
    intern/COM_NodeOperationBuilder.cc
    intern/COM_NodeOperationBuilder.h
    intern/COM_OpenCLDevice.cc
    intern/COM_OpenCLDevice.h
    intern/COM_SharedOperationBuffers.cc
    intern/COM_SharedOperationBuffers.h
    intern/COM_SingleThreadedOperation.cc
    intern/COM_SingleThreadedOperation.h
    intern/COM_TiledExecutionModel.cc
    intern/COM_TiledExecutionModel.h
    intern/COM_WorkPackage.cc
    intern/COM_WorkPackage.h
    intern/COM_WorkScheduler.cc
    intern/COM_WorkScheduler.h
    intern/COM_compositor.cc

    operations/COM_QualityStepHelper.cc
    operations/COM_QualityStepHelper.h

    # Internal nodes
    nodes/COM_SocketProxyNode.cc
    nodes/COM_SocketProxyNode.h

    # input nodes
    nodes/COM_BokehImageNode.cc
    nodes/COM_BokehImageNode.h
    nodes/COM_ColorNode.cc
    nodes/COM_ColorNode.h
    nodes/COM_ImageNode.cc
    nodes/COM_ImageNode.h
    nodes/COM_MaskNode.cc
    nodes/COM_MaskNode.h
    nodes/COM_MovieClipNode.cc
    nodes/COM_MovieClipNode.h
    nodes/COM_OutputFileNode.cc
    nodes/COM_OutputFileNode.h
    nodes/COM_RenderLayersNode.cc
    nodes/COM_RenderLayersNode.h
    nodes/COM_SceneTimeNode.cc
    nodes/COM_SceneTimeNode.h
    nodes/COM_SwitchNode.cc
    nodes/COM_SwitchNode.h
    nodes/COM_SwitchViewNode.cc
    nodes/COM_SwitchViewNode.h
    nodes/COM_TextureNode.cc
    nodes/COM_TextureNode.h
    nodes/COM_TimeNode.cc
    nodes/COM_TimeNode.h
    nodes/COM_ValueNode.cc
    nodes/COM_ValueNode.h

    # output nodes
    nodes/COM_CompositorNode.cc
    nodes/COM_CompositorNode.h
    nodes/COM_SplitViewerNode.cc
    nodes/COM_SplitViewerNode.h
    nodes/COM_ViewLevelsNode.cc
    nodes/COM_ViewLevelsNode.h
    nodes/COM_ViewerNode.cc
    nodes/COM_ViewerNode.h
    operations/COM_CalculateMeanOperation.cc
    operations/COM_CalculateMeanOperation.h
    operations/COM_CalculateStandardDeviationOperation.cc
    operations/COM_CalculateStandardDeviationOperation.h

    # distort nodes
    nodes/COM_FlipNode.cc
    nodes/COM_FlipNode.h
    nodes/COM_RotateNode.cc
    nodes/COM_RotateNode.h
    nodes/COM_ScaleNode.cc
    nodes/COM_ScaleNode.h
    nodes/COM_TranslateNode.cc
    nodes/COM_TranslateNode.h

    nodes/COM_DisplaceNode.cc
    nodes/COM_DisplaceNode.h
    nodes/COM_MapUVNode.cc
    nodes/COM_MapUVNode.h

    nodes/COM_ChannelMatteNode.cc
    nodes/COM_ChannelMatteNode.h
    nodes/COM_ChromaMatteNode.cc
    nodes/COM_ChromaMatteNode.h
    nodes/COM_ColorMatteNode.cc
    nodes/COM_ColorMatteNode.h
    nodes/COM_DifferenceMatteNode.cc
    nodes/COM_DifferenceMatteNode.h
    nodes/COM_DistanceMatteNode.cc
    nodes/COM_DistanceMatteNode.h
    nodes/COM_LensDistortionNode.cc
    nodes/COM_LensDistortionNode.h
    nodes/COM_LuminanceMatteNode.cc
    nodes/COM_LuminanceMatteNode.h

    nodes/COM_GlareNode.cc
    nodes/COM_GlareNode.h

    nodes/COM_SunBeamsNode.cc
    nodes/COM_SunBeamsNode.h
    operations/COM_SunBeamsOperation.cc
    operations/COM_SunBeamsOperation.h

    nodes/COM_CryptomatteNode.cc
    nodes/COM_CryptomatteNode.h
    operations/COM_CryptomatteOperation.cc
    operations/COM_CryptomatteOperation.h

    nodes/COM_CornerPinNode.cc
    nodes/COM_CornerPinNode.h
    nodes/COM_PlaneTrackDeformNode.cc
    nodes/COM_PlaneTrackDeformNode.h

    nodes/COM_CropNode.cc
    nodes/COM_CropNode.h
    operations/COM_CropOperation.cc
    operations/COM_CropOperation.h

    nodes/COM_DefocusNode.cc
    nodes/COM_DefocusNode.h
    nodes/COM_MovieDistortionNode.cc
    nodes/COM_MovieDistortionNode.h
    nodes/COM_Stabilize2dNode.cc
    nodes/COM_Stabilize2dNode.h
    nodes/COM_TransformNode.cc
    nodes/COM_TransformNode.h

    # color nodes
    nodes/COM_AlphaOverNode.cc
    nodes/COM_AlphaOverNode.h
    nodes/COM_BrightnessNode.cc
    nodes/COM_BrightnessNode.h
    nodes/COM_ColorBalanceNode.cc
    nodes/COM_ColorBalanceNode.h
    nodes/COM_ColorCorrectionNode.cc
    nodes/COM_ColorCorrectionNode.h
    nodes/COM_ColorCurveNode.cc
    nodes/COM_ColorCurveNode.h
    nodes/COM_ColorExposureNode.cc
    nodes/COM_ColorExposureNode.h
    nodes/COM_ColorRampNode.cc
    nodes/COM_ColorRampNode.h
    nodes/COM_ColorToBWNode.cc
    nodes/COM_ColorToBWNode.h
    nodes/COM_ConvertAlphaNode.cc
    nodes/COM_ConvertAlphaNode.h
    nodes/COM_ConvertColorSpaceNode.cc
    nodes/COM_ConvertColorSpaceNode.h
    nodes/COM_GammaNode.cc
    nodes/COM_GammaNode.h
    nodes/COM_HueSaturationValueCorrectNode.cc
    nodes/COM_HueSaturationValueCorrectNode.h
    nodes/COM_HueSaturationValueNode.cc
    nodes/COM_HueSaturationValueNode.h
    nodes/COM_InvertNode.cc
    nodes/COM_InvertNode.h
    nodes/COM_MixNode.cc
    nodes/COM_MixNode.h
    nodes/COM_SetAlphaNode.cc
    nodes/COM_SetAlphaNode.h
    nodes/COM_TonemapNode.cc
    nodes/COM_TonemapNode.h
    nodes/COM_VectorCurveNode.cc
    nodes/COM_VectorCurveNode.h
    nodes/COM_ZCombineNode.cc
    nodes/COM_ZCombineNode.h
    operations/COM_TonemapOperation.cc
    operations/COM_TonemapOperation.h

    # converter nodes
    nodes/COM_CombineColorNode.cc
    nodes/COM_CombineColorNode.h
    nodes/COM_CombineColorNodeLegacy.cc
    nodes/COM_CombineColorNodeLegacy.h
    nodes/COM_CombineXYZNode.cc
    nodes/COM_CombineXYZNode.h
    nodes/COM_IDMaskNode.cc
    nodes/COM_IDMaskNode.h
    nodes/COM_SeparateColorNode.cc
    nodes/COM_SeparateColorNode.h
    nodes/COM_SeparateColorNodeLegacy.cc
    nodes/COM_SeparateColorNodeLegacy.h
    nodes/COM_SeparateXYZNode.cc
    nodes/COM_SeparateXYZNode.h

    nodes/COM_MapRangeNode.cc
    nodes/COM_MapRangeNode.h
    nodes/COM_MapValueNode.cc
    nodes/COM_MapValueNode.h
    nodes/COM_MathNode.cc
    nodes/COM_MathNode.h
    nodes/COM_NormalNode.cc
    nodes/COM_NormalNode.h
    nodes/COM_NormalizeNode.cc
    nodes/COM_NormalizeNode.h

    operations/COM_NormalizeOperation.cc
    operations/COM_NormalizeOperation.h

    nodes/COM_PixelateNode.cc
    nodes/COM_PixelateNode.h
    operations/COM_PixelateOperation.cc
    operations/COM_PixelateOperation.h

    # Filter nodes
    nodes/COM_BilateralBlurNode.cc
    nodes/COM_BilateralBlurNode.h
    operations/COM_BilateralBlurOperation.cc
    operations/COM_BilateralBlurOperation.h
    nodes/COM_VectorBlurNode.cc
    nodes/COM_VectorBlurNode.h
    operations/COM_VectorBlurOperation.cc
    operations/COM_VectorBlurOperation.h
    nodes/COM_AntiAliasingNode.cc
    nodes/COM_AntiAliasingNode.h
    nodes/COM_BlurNode.cc
    nodes/COM_BlurNode.h
    nodes/COM_BokehBlurNode.cc
    nodes/COM_BokehBlurNode.h
    nodes/COM_DenoiseNode.cc
    nodes/COM_DenoiseNode.h
    nodes/COM_DespeckleNode.cc
    nodes/COM_DespeckleNode.h
    nodes/COM_DilateErodeNode.cc
    nodes/COM_DilateErodeNode.h
    nodes/COM_DirectionalBlurNode.cc
    nodes/COM_DirectionalBlurNode.h
    nodes/COM_FilterNode.cc
    nodes/COM_FilterNode.h
    nodes/COM_InpaintNode.cc
    nodes/COM_InpaintNode.h
    nodes/COM_KuwaharaNode.cc
    nodes/COM_KuwaharaNode.h
    nodes/COM_PosterizeNode.cc
    nodes/COM_PosterizeNode.h

    operations/COM_BlurBaseOperation.cc
    operations/COM_BlurBaseOperation.h
    operations/COM_BokehBlurOperation.cc
    operations/COM_BokehBlurOperation.h
    operations/COM_DirectionalBlurOperation.cc
    operations/COM_DirectionalBlurOperation.h
    operations/COM_FastGaussianBlurOperation.cc
    operations/COM_FastGaussianBlurOperation.h
    operations/COM_GammaCorrectOperation.cc
    operations/COM_GammaCorrectOperation.h
    operations/COM_GaussianAlphaBlurBaseOperation.cc
    operations/COM_GaussianAlphaBlurBaseOperation.h
    operations/COM_GaussianAlphaXBlurOperation.cc
    operations/COM_GaussianAlphaXBlurOperation.h
    operations/COM_GaussianAlphaYBlurOperation.cc
    operations/COM_GaussianAlphaYBlurOperation.h
    operations/COM_GaussianBlurBaseOperation.cc
    operations/COM_GaussianBlurBaseOperation.h
    operations/COM_GaussianBokehBlurOperation.cc
    operations/COM_GaussianBokehBlurOperation.h
    operations/COM_GaussianXBlurOperation.cc
    operations/COM_GaussianXBlurOperation.h
    operations/COM_GaussianYBlurOperation.cc
    operations/COM_GaussianYBlurOperation.h
    operations/COM_KuwaharaAnisotropicOperation.cc
    operations/COM_KuwaharaAnisotropicOperation.h
    operations/COM_KuwaharaAnisotropicStructureTensorOperation.cc
    operations/COM_KuwaharaAnisotropicStructureTensorOperation.h
    operations/COM_KuwaharaClassicOperation.cc
    operations/COM_KuwaharaClassicOperation.h
    operations/COM_MovieClipAttributeOperation.cc
    operations/COM_MovieClipAttributeOperation.h
    operations/COM_MovieDistortionOperation.cc
    operations/COM_MovieDistortionOperation.h
    operations/COM_PosterizeOperation.cc
    operations/COM_PosterizeOperation.h
    operations/COM_SMAAOperation.cc
    operations/COM_SMAAOperation.h
    operations/COM_VariableSizeBokehBlurOperation.cc
    operations/COM_VariableSizeBokehBlurOperation.h

    # Matte nodes
    nodes/COM_BoxMaskNode.cc
    nodes/COM_BoxMaskNode.h
    nodes/COM_ColorSpillNode.cc
    nodes/COM_ColorSpillNode.h
    nodes/COM_DoubleEdgeMaskNode.cc
    nodes/COM_DoubleEdgeMaskNode.h
    nodes/COM_EllipseMaskNode.cc
    nodes/COM_EllipseMaskNode.h

    operations/COM_DoubleEdgeMaskOperation.cc
    operations/COM_DoubleEdgeMaskOperation.h


    nodes/COM_KeyingScreenNode.cc
    nodes/COM_KeyingScreenNode.h
    operations/COM_KeyingScreenOperation.cc
    operations/COM_KeyingScreenOperation.h

    nodes/COM_TrackPositionNode.cc
    nodes/COM_TrackPositionNode.h
    operations/COM_TrackPositionOperation.cc
    operations/COM_TrackPositionOperation.h

    nodes/COM_KeyingNode.cc
    nodes/COM_KeyingNode.h
    operations/COM_KeyingBlurOperation.cc
    operations/COM_KeyingBlurOperation.h
    operations/COM_KeyingClipOperation.cc
    operations/COM_KeyingClipOperation.h
    operations/COM_KeyingDespillOperation.cc
    operations/COM_KeyingDespillOperation.h

=== source/blender/editors/util/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 Blender Authors
#
# SPDX-License-Identifier: GPL-2.0-or-later

set(INC
  ../include
  ../space_sequencer
  ../../asset_system
  ../../blenfont
  ../../blenkernel
  ../../blentranslation
  ../../bmesh
  ../../depsgraph
  ../../gpu
  ../../imbuf
  ../../makesrna
  ../../sequencer
  ../../windowmanager
  ../../../../intern/clog
  # RNA_prototypes.h
  ${CMAKE_BINARY_DIR}/source/blender/makesrna
)

set(INC_SYS
)

set(SRC
  ed_draw.cc
  ed_transverts.cc
  ed_util.cc
  ed_util_imbuf.cc
  ed_util_ops.cc
  ed_viewer_path.cc
  gizmo_utils.cc
  numinput.cc
  select_utils.cc

  # general includes
  ../include/BIF_glutil.hh
  ../include/ED_anim_api.hh
  ../include/ED_armature.hh
  ../include/ED_asset.hh
  ../include/ED_asset_menu_utils.hh
  ../include/ED_buttons.hh
  ../include/ED_clip.hh
  ../include/ED_curve.hh
  ../include/ED_curves.hh
  ../include/ED_curves_sculpt.hh
  ../include/ED_datafiles.h
  ../include/ED_file_indexer.hh
  ../include/ED_fileselect.hh
  ../include/ED_geometry.hh
  ../include/ED_gizmo_library.hh
  ../include/ED_gizmo_utils.hh
  ../include/ED_gpencil_legacy.hh
  ../include/ED_grease_pencil.hh
  ../include/ED_image.hh
  ../include/ED_info.hh
  ../include/ED_keyframes_draw.hh
  ../include/ED_keyframes_edit.hh
  ../include/ED_keyframes_keylist.hh
  ../include/ED_keyframing.hh
  ../include/ED_lattice.hh
  ../include/ED_markers.hh
  ../include/ED_mask.hh
  ../include/ED_mball.hh
  ../include/ED_mesh.hh
  ../include/ED_node.hh
  ../include/ED_node_c.hh
  ../include/ED_node_preview.hh
  ../include/ED_numinput.hh
  ../include/ED_object.hh
  ../include/ED_outliner.hh
  ../include/ED_paint.hh
  ../include/ED_particle.hh
  ../include/ED_physics.hh
  ../include/ED_render.hh
  ../include/ED_scene.hh
  ../include/ED_screen.hh
  ../include/ED_screen_types.hh
  ../include/ED_sculpt.hh
  ../include/ED_select_utils.hh
  ../include/ED_sequencer.hh
  ../include/ED_sound.hh
  ../include/ED_space_api.hh
  ../include/ED_spreadsheet.hh
  ../include/ED_text.hh
  ../include/ED_time_scrub_ui.hh
  ../include/ED_transform.hh
  ../include/ED_transform_snap_object_context.hh
  ../include/ED_transverts.hh
  ../include/ED_undo.hh
  ../include/ED_userpref.hh
  ../include/ED_util.hh
  ../include/ED_util_imbuf.hh
  ../include/ED_uvedit.hh
  ../include/ED_view3d.hh
  ../include/ED_view3d_offscreen.hh
  ../include/ED_viewer_path.hh
  ../include/UI_abstract_view.hh
  ../include/UI_grid_view.hh
  ../include/UI_icons.hh
  ../include/UI_interface.hh
  ../include/UI_interface_c.hh
  ../include/UI_interface_icons.hh
  ../include/UI_resources.hh
  ../include/UI_string_search.hh
  ../include/UI_tree_view.hh
  ../include/UI_view2d.hh
)

set(LIB
  PRIVATE bf::animrig
  PRIVATE bf::blenlib
  PRIVATE bf::dna
  PRIVATE bf::intern::guardedalloc
)


if(WITH_PYTHON)
  add_definitions(-DWITH_PYTHON)
  list(APPEND INC
    ../../python
  )
endif()

blender_add_lib(bf_editor_util "${SRC}" "${INC}" "${INC_SYS}" "${LIB}")

# RNA_prototypes.h
add_dependencies(bf_editor_util bf_rna)

=== PKGBUILD ===
# Maintainer: Alexey Pavlov <alexpux@gmail.com>
# To build with Qt-Creator:
# 1. Launch Qt-Creator with the env (set from cmd.exe):
# set "MINGW_PREFIX=C:/msys64/mingw64"
# set "ACLOCAL_PATH=%MINGW_PREFIX%/share/aclocal:/usr/share/aclocal"
# set "PKG_CONFIG_PATH=%MINGW_PREFIX%/lib/pkgconfig"
# set "PATH=%MINGW_PREFIX%/bin;%PATH%"
# 2. Specify the following as the CMake arguments:
# -DMINGW_LIBS=%MINGW_PREFIX% -DCMAKE_BUILD_TYPE=Debug -DWITH_SYSTEM_GLEW=ON -DWITH_SYSTEM_OPENJPEG=ON -DWITH_INSTALL_PORTABLE=OFF -DWITH_OPENCOLLADA=ON -DWITH_GAMEENGINE=ON -DWITH_RAYOPTIMIZATION=ON -DWITH_JACK=OFF -DWITH_PLAYER=ON -DWITH_CODEC_FFMPEG=ON -DWITH_CODEC_SNDFILE=ON -DWITH_CYCLES=ON -DWITH_CYCLES_CUDA_BINARIES=OFF -DWITH_CYCLES_OSL=ON -DWITH_FFTW3=ON -DWITH_MOD_OCEANSIM=ON -DPYTHON_VERSION=3.7 -DPYTHON_LIBPATH=%MINGW_PREFIX%/lib -DPYTHON_LIBRARY="python3.6m" -DPYTHON_INCLUDE_DIRS=/msys64/mingw64/include/python3.6m -DWITH_PYTHON_INSTALL=OFF -DWITH_PYTHON_INSTALL_NUMPY=OFF -DPYTHON_NUMPY_PATH=%MINGW_PREFIX%/lib/python3.6/site-packages -DCYCLES_OSL=%MINGW_PREFIX% -DWITH_IMAGE_REDCODE=ON -DWITH_OPENMP=ON -DWITH_LLVM=ON -DLLVM_STATIC=ON

_realname=blender
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=4.0.2
pkgrel=12
pkgdesc="A fully integrated 3D graphics creation suite (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://www.blender.org"
msys2_repository_url="https://projects.blender.org/blender/blender"
msys2_references=(
  'archlinux: blender'
  'cpe: cpe:/a:blender:blender'
)
license=('spdx:GPL-2.0-or-later')
# build conflict with "${MINGW_PACKAGE_PREFIX}-glog"
depends=("${MINGW_PACKAGE_PREFIX}-alembic"
         #"${MINGW_PACKAGE_PREFIX}-audaspace"
         "${MINGW_PACKAGE_PREFIX}-boost-libs"
         #"${MINGW_PACKAGE_PREFIX}-bullet-dp"
         #"${MINGW_PACKAGE_PREFIX}-draco" It builds an internal library
         "${MINGW_PACKAGE_PREFIX}-embree"
         "${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-gmp"
         "${MINGW_PACKAGE_PREFIX}-ffmpeg"
         "${MINGW_PACKAGE_PREFIX}-fftw"
         "${MINGW_PACKAGE_PREFIX}-freetype"
         #"${MINGW_PACKAGE_PREFIX}-gflags"
         #"${MINGW_PACKAGE_PREFIX}-glog"
         "${MINGW_PACKAGE_PREFIX}-imath"
         #"${MINGW_PACKAGE_PREFIX}-jemalloc"
         "${MINGW_PACKAGE_PREFIX}-libepoxy"
         "${MINGW_PACKAGE_PREFIX}-libharu"
         "${MINGW_PACKAGE_PREFIX}-libiconv"
         "${MINGW_PACKAGE_PREFIX}-libjpeg-turbo"
         "${MINGW_PACKAGE_PREFIX}-libpng"
         "${MINGW_PACKAGE_PREFIX}-libsndfile"
         "${MINGW_PACKAGE_PREFIX}-libtiff"
         "${MINGW_PACKAGE_PREFIX}-libwebp"
         "${MINGW_PACKAGE_PREFIX}-libwinpthread-git"
         "${MINGW_PACKAGE_PREFIX}-lzo2"
         #"${MINGW_PACKAGE_PREFIX}-materialx"
         #"${MINGW_PACKAGE_PREFIX}-usd"
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-openal"
         "${MINGW_PACKAGE_PREFIX}-opencollada"
         "${MINGW_PACKAGE_PREFIX}-opencolorio"
         "${MINGW_PACKAGE_PREFIX}-openexr"
         $([[ ${CARCH} == aarch64 ]] || echo "${MINGW_PACKAGE_PREFIX}-openimagedenoise")
         "${MINGW_PACKAGE_PREFIX}-openimageio"
         "${MINGW_PACKAGE_PREFIX}-openjpeg2"
         "${MINGW_PACKAGE_PREFIX}-openpgl"
         "${MINGW_PACKAGE_PREFIX}-openshadinglanguage"
         "${MINGW_PACKAGE_PREFIX}-opensubdiv"
         "${MINGW_PACKAGE_PREFIX}-openvdb"
         "${MINGW_PACKAGE_PREFIX}-openxr-sdk"
         "${MINGW_PACKAGE_PREFIX}-potrace"
         "${MINGW_PACKAGE_PREFIX}-pugixml"
         "${MINGW_PACKAGE_PREFIX}-python"
         "${MINGW_PACKAGE_PREFIX}-python-numpy"
         "${MINGW_PACKAGE_PREFIX}-SDL2"
         "${MINGW_PACKAGE_PREFIX}-tbb"
         "${MINGW_PACKAGE_PREFIX}-zlib"
         "${MINGW_PACKAGE_PREFIX}-zstd")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-boost"
             "${MINGW_PACKAGE_PREFIX}-eigen3"
             "${MINGW_PACKAGE_PREFIX}-wintab-sdk"
             $([[ "$CARCH" == "aarch64" ]] && echo "${MINGW_PACKAGE_PREFIX}-sse2neon"))
install=blender-${MSYSTEM}.install
source=(https://download.blender.org/source/${_realname}-${pkgver}.tar.xz
        blender-addons-${pkgver}.tar.gz::https://projects.blender.org/blender/blender-addons/archive/v${pkgver}.tar.gz
        0001-mingw-buildsystem.patch
        0002-fix-mingw-w64-definitions.patch
        0003-disable-static_assert_align-on-mingw.patch
        0004-fix-build-with-openpgl-0.6.patch::https://projects.blender.org/blender/blender/pulls/118328.patch
        0005-fix-WINTAB_PRINTF-on-mingw.patch
        0006-mingw-DEBUG-libmv-avoid-too-many-sections.patch
        0007-disable-compiler-warnings.patch
        0008-mingw-use-X11-like-path-layout.patch
        0009-include-missing-headers.patch
        0010-llvm-no-longer-needed.patch::https://projects.blender.org/blender/blender/commit/088ae8d9.patch
        0011-no-TIME_UTC-on-msvcrt.patch
        0012-fix-build-with-OSL-1.13.patch::https://projects.blender.org/blender/blender/commit/798a0b30.patch
        0013-force-draco.patch
        0014-fix-find-numpy-2.patch
        0015-mingw-python-like-msvc.patch
        0016-mingw-windres.patch
        0017-fix-build-with-python-3.12.patch::https://github.com/blender/blender/commit/252ae702.patch
        0018-fix-work-with-openvdb-11.patch::https://projects.blender.org/blender/blender/commit/bbb7e7a6.patch
        0019-fix-casts.patch
        0020-blendthumb-build.patch
        0021-fix-build-with-openvdb-12.patch::https://projects.blender.org/blender/blender/commit/43326458.patch
        0022-find-llvm-convert-paths.patch
        0023-link-errors.patch
        0024-openvdb-shared.patch
        0025-callback-function-prototype-fix.patch
        0028-use-std-namespace.patch
        0032-fix-finding-tbb.patch
        0033-dont-add-fno-rtti-compile-option.patch
        0034-Fix-ARM64-Build.patch
        0035-Enable-SSE2NEON-on-Windows-ARM.patch
        0039-no-WRL-on-mingw-w64.patch
        ffmpeg-7-1.patch
        ffmpeg-7-2.patch)
sha256sums=('aaa0e729da7591cfbf45772af76345977daaa7b11a0af35d98f9313e246077a3'
            '16e9a9845e0db4e59d3be40f18dc631ab834f418cb226433947a90323e7c847b'
            'ee9b8f5c191a59960682729d89f7c51e3c9bf50992d6b86f933d05b98e4c5a72'
            '11fd854c62dc276f3edace85e285764506091e9203abf7c90dcad98005e9cfc7'
            '891c19119b5cb6ff05b93ed8183841593bc20444dd4070bc5c69a701d857e030'
            'de81f189dcef9ad0d46c57f16bc618751d6e749765cfb4d8e9c132ffcbd86c1d'
            '2cd8eea86a67a330d8eadb09ec1bafbe99a4c910654aa65dc1c6389b1e6ae678'
            '1ccbf571e8dae23d0bff4ac848825788ac0a838261c5b02578c30852061238c8'
            '94b1299ff8fff061e1387e5ed14b4c1c58ae834c30c3360a0c53aaadf226064f'
            '9822ab6ab47fb67e8a75df44c3a7c3cdd060ad0c63acb87eeeea0be53bb0f252'
            '05aabd1aef3f0894889117dafc51e9d63929eb64b22fc5790a066850f8fe7388'
            '6b8a01acb726b984960d95ce7da5b69204b2d80ebaa6c2c5a7a87924ea26b986'
            'e018b7ee07f7b8b4964fd30feb0495101d0a6b51f218652d12ae2b6369d495eb'
            '44879c20e31e60ebe3232f0be9d808b343cf986f7a0fc6df53a90ac270ab42be'
            '6b08689f6c050780feebee330ad7c40cc528556ef80cb817e1551b11123edd13'
            '06444eeb84d61437527d402c376024a862e60766963273868d76c604185829d1'
            '54f2569620eca6a6ad9e628a523a44bcddf96d863b749354f8bc5dd324dabeac'
            '98e61ea711a8356927d105b3e8ce0d65fb8fa62b8cfbcbc91d8d9b13f285d74b'
            '396ff56fc87a48f80fcad4f83253f61285f4394e08bec24be7a3249f26585e33'
            'ecc09cdca976fd98eb50f94c20f98cf92dbb7efb57657a2619c4dec1a4effdaf'
            'a1a2e9aa9950e4438576291518c649074b6a0c473429bc16494995a981de614b'
            '77139f37224bc9921e05394909ec4c698af3089d97d0293ec4cd3aade252858a'
            '1703759a4e003414ae0f2856731f2da029d8be5995745768d6f260d60da7399e'
            '8be734582b9980ad0a3c5a82c200767ce558084f18e3cca11947991a14b0d68a'
            '06e2c8d66ebea68e8da1584c9e3f7a6dd97619ebf32d53c5ea611164a45c7f8a'
            'c39bfb8c5e4f6d26601e9cb03b979265ff0bbbcb2d2758005a4d0b0ed9616c7f'
            '37927b5a4e93461343841c84bdd1c67755bd03ac14d454ad8f4a952c37049ff7'
            'f9d9d4774e8714d7880cee022ba81db969469528263e7279a0f150f276fb47f8'
            '7c2df0ecdb825b0e6c7899139372ff3ebef0244241ce8dec216c8bbbb09c82a0'
            '16b560363717357a0e69d3b46269cace9bf978126e08b604ad18a532a8dfd0b2'
            'a48e49b9e6034ccd3b448bc44f4f30a4d64682e8820f68d470069c9cbcf8b6c7'
            '439c4d0978e3690f42a2c7b84a9fa91ed9b27979f244d4e8edd1461fe20d7011'
            '70d0cfa0ca9f7a948b248174ab516867f31e76361b7aabb70de05688ee78f92c'
            '17d5fb1c4ddb9e95da590d2e43ae3f7ce2b02c3ec698b16ed2752e3b3e7840c0'
            '499a9ec9a1aa7c5ef26ce5bb26f48576cccf1fc5906e966f92e25506405e9ad0')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd "${srcdir}"/${_realname}-${pkgver}

  rm -rf scripts/addons && mv "${srcdir}"/blender-addons scripts/addons

  rm -f build_files/cmake/platform/platform_win32_mingw64.cmake
  rm -f release/windows/icons/blender.exe.manifest

  apply_patch_with_msg \
    0001-mingw-buildsystem.patch \
    0002-fix-mingw-w64-definitions.patch \
    0003-disable-static_assert_align-on-mingw.patch \
    0004-fix-build-with-openpgl-0.6.patch \
    0005-fix-WINTAB_PRINTF-on-mingw.patch \
    0006-mingw-DEBUG-libmv-avoid-too-many-sections.patch \
    0007-disable-compiler-warnings.patch \
    0008-mingw-use-X11-like-path-layout.patch \
    0009-include-missing-headers.patch \
    0010-llvm-no-longer-needed.patch \
    0011-no-TIME_UTC-on-msvcrt.patch \
    0012-fix-build-with-OSL-1.13.patch \
    0013-force-draco.patch \
    0014-fix-find-numpy-2.patch \
    0015-mingw-python-like-msvc.patch \
    0016-mingw-windres.patch \
    0017-fix-build-with-python-3.12.patch \
    0018-fix-work-with-openvdb-11.patch \
    0019-fix-casts.patch \
    0020-blendthumb-build.patch \
    0021-fix-build-with-openvdb-12.patch \
    0022-find-llvm-convert-paths.patch \
    0023-link-errors.patch \
    0024-openvdb-shared.patch \
    0025-callback-function-prototype-fix.patch \
    0028-use-std-namespace.patch \
    0032-fix-finding-tbb.patch \
    0033-dont-add-fno-rtti-compile-option.patch \
    0034-Fix-ARM64-Build.patch \
    0035-Enable-SSE2NEON-on-Windows-ARM.patch \
    0039-no-WRL-on-mingw-w64.patch

  # https://projects.blender.org/blender/blender/pulls/121960
  # https://projects.blender.org/blender/blender/pulls/121947
  apply_patch_with_msg \
    ffmpeg-7-1.patch \
    ffmpeg-7-2.patch

  # Remove *.orig files
  find . -type f -name "*.orig" -exec rm -f {} \;
}

build() {
  mkdir -p "${srcdir}"/build-${MSYSTEM}  && cd "${srcdir}"/build-${MSYSTEM}

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  CXXFLAGS+=" -w"
  CFLAGS+=" -w"
  if [[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]]; then
    CXXFLAGS+=" -Wno-c++11-narrowing"
    CFLAGS+=" -Wno-unreachable-code-generic-assoc"
  fi

  if [[ $MINGW_PACKAGE_PREFIX != *-clang-* ]]; then
    CFLAGS+=" -Wno-incompatible-pointer-types"
  fi

  if [[ $CARCH == "aarch64" ]]; then
    _extra_config+=("-DSSE2NEON_ROOT_DIR=${MINGW_PREFIX}/include/sse2neon")
  fi

  export XR_OPENXR_SDK_ROOT_DIR=${MINGW_PREFIX}
  export EMBREE_ROOT_DIR=${MINGW_PREFIX}

  _pyver=$(${MINGW_PREFIX}/bin/python -c "import sys;sys.stdout.write('.'.join(map(str, sys.version_info[:2])))")

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    -G"Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    "${_extra_config[@]}" \
    -DWITH_SYSTEM_AUDASPACE=OFF \
    -DWITH_SYSTEM_GFLAGS=OFF \
    -DWITH_SYSTEM_GLOG=OFF \
